scala.tools.nsc.backend.jvm.BCodeSkelBuilder

# PlainSkelBuilder

###
Related Doc: package BCodeSkelBuilder

#### abstract class PlainSkelBuilder extends BCClassGen with BCAnnotGen with BCInnerClassGen with JAndroidBuilder with BCForwardersGen with BCPickles with BCJGenSigGen

Source
  BCodeSkelBuilder.scala

Linear Supertypes
BCodeSkelBuilder.BCPickles, BCodeSkelBuilder.BCForwardersGen, BCodeSkelBuilder.BCJGenSigGen, BCodeSkelBuilder.JAndroidBuilder, BCodeSkelBuilder.BCAnnotGen, BCodeSkelBuilder.BCClassGen, BCodeSkelBuilder.BCInnerClassGen, AnyRef, Any
Known Subclasses
PlainBodyBuilder, PlainClassBuilder, SyncAndTryBuilder
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. PlainSkelBuilder
2. BCPickles
3. BCForwardersGen
4. BCJGenSigGen
5. JAndroidBuilder
6. BCAnnotGen
7. BCClassGen
8. BCInnerClassGen
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new PlainSkelBuilder(cunit: Global.CompilationUnit)

### Type Members

1. #### case class Local (tk: BTypesFromSymbols.BType, name: String, idx: Int, isSynth: Boolean) extends Product with Serializable

### Abstract Value Members

1. #### abstract def genLoad(tree: Global.Tree, expectedType: BTypesFromSymbols.BType): Unit

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from PlainSkelBuilder to any2stringadd[PlainSkelBuilder] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (PlainSkelBuilder, B)

   Implicit information
     This member is added by an implicit conversion from PlainSkelBuilder to ArrowAssoc[PlainSkelBuilder] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val MIN_SWITCH_DENSITY: Double

   Definition Classes
     BCClassGen

7. #### final val MaximumJvmParameters: Int(254)

8. #### def addClassFields(): Unit

9. #### def addForwarders(isRemoteClass: Boolean, jclass: ClassVisitor, jclassName: String, moduleClass: Global.Symbol): Unit

   Definition Classes
     BCForwardersGen

10. #### def addLambdaDeserialize(clazz: Global.Symbol, jclass: ClassVisitor): Unit

    Add: private static java.util.Map $deserializeLambdaCache$ = null private static Object $deserializeLambda$(SerializedLambda l) { var cache = $deserializeLambdaCache$ if (cache eq null) { cache = new java.util.HashMap() $deserializeLambdaCache$ = cache } return scala.compat.java8.runtime.LambdaDeserializer.deserializeLambda(MethodHandles.lookup(), cache, l); }

    Add: private static java.util.Map $deserializeLambdaCache$ = null private static Object $deserializeLambda$(SerializedLambda l) { var cache = $deserializeLambdaCache$ if (cache eq null) { cache = new java.util.HashMap() $deserializeLambdaCache$ = cache } return scala.compat.java8.runtime.LambdaDeserializer.deserializeLambda(MethodHandles.lookup(), cache, l); }

    Definition Classes
      BCClassGen

11. #### def addRemoteExceptionAnnot(isRemoteClass: Boolean, isJMethodPublic: Boolean, meth: Global.Symbol): Unit

    Definition Classes
      BCForwardersGen

12. #### def addSerialVUID(id: Long, jclass: ClassVisitor): Unit

    Definition Classes
      BCClassGen

13. #### val androidFieldName: Global.TermName

    Definition Classes
      JAndroidBuilder

14. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

15. #### final def asmMethodType(msym: Global.Symbol): BTypesFromSymbols.MethodBType

    Class components that are nested classes are added to the innerClassBufferASM.

    Class components that are nested classes are added to the innerClassBufferASM. TODO: clean up the way we track referenced inner classes.

    Definition Classes
      BCInnerClassGen

16. #### object bc extends BCodeSkelBuilder.JCodeMethodN

17. #### var claszSymbol: Global.Symbol

18. #### var cleanups: List[Label]

19. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

20. #### var cnode: ClassNode

21. #### def createJAttribute(name: String, b: Array[Byte], offset: Int, len: Int): Attribute

    Definition Classes
      BCPickles

22. #### def currProgramPoint(): Label

23. #### def debugLevel: Int

    Definition Classes
      BCInnerClassGen

24. #### final def descriptor(sym: Global.Symbol): String

    The jvm descriptor for a symbol.

    The jvm descriptor for a symbol. If `sym` represents a nested class, its ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

25. #### final def descriptor(t: Global.Type): String

    The jvm descriptor of a type.

    The jvm descriptor of a type. If `t` references a nested class, its ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

26. #### var earlyReturnVar: Global.Symbol

27. #### def emitAnnotations(fw: FieldVisitor, annotations: List[Global.AnnotationInfo]): Unit

    Definition Classes
      BCAnnotGen

28. #### def emitAnnotations(mw: MethodVisitor, annotations: List[Global.AnnotationInfo]): Unit

    Definition Classes
      BCAnnotGen

29. #### def emitAnnotations(cw: ClassVisitor, annotations: List[Global.AnnotationInfo]): Unit

    Definition Classes
      BCAnnotGen

30. #### def emitArgument(av: AnnotationVisitor, name: String, arg: Global.ClassfileAnnotArg): Unit

    Definition Classes
      BCAnnotGen

31. #### def emitAssocs(av: AnnotationVisitor, assocs: List[(Global.Name, Global.ClassfileAnnotArg)]): Unit

    Definition Classes
      BCAnnotGen

32. #### final val emitLines: Boolean

    Definition Classes
      BCInnerClassGen

33. #### def emitLocalVarScope(sym: Global.Symbol, start: Label, end: Label, force: Boolean = false): Unit

34. #### def emitParamAnnotations(jmethod: MethodVisitor, pannotss: List[List[Global.AnnotationInfo]]): Unit

    Definition Classes
      BCAnnotGen

35. #### final val emitSource: Boolean

    Definition Classes
      BCInnerClassGen

36. #### final val emitVars: Boolean

    Definition Classes
      BCInnerClassGen

37. #### def ensuring(cond: (PlainSkelBuilder) ⇒ Boolean, msg: ⇒ Any): PlainSkelBuilder

    Implicit information
      This member is added by an implicit conversion from PlainSkelBuilder to Ensuring[PlainSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

38. #### def ensuring(cond: (PlainSkelBuilder) ⇒ Boolean): PlainSkelBuilder

    Implicit information
      This member is added by an implicit conversion from PlainSkelBuilder to Ensuring[PlainSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

39. #### def ensuring(cond: Boolean, msg: ⇒ Any): PlainSkelBuilder

    Implicit information
      This member is added by an implicit conversion from PlainSkelBuilder to Ensuring[PlainSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

40. #### def ensuring(cond: Boolean): PlainSkelBuilder

    Implicit information
      This member is added by an implicit conversion from PlainSkelBuilder to Ensuring[PlainSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

41. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

42. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

43. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

44. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from PlainSkelBuilder to StringFormat[PlainSkelBuilder] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

45. #### def gen(tree: Global.Tree): Unit

46. #### def genDefDef(dd: Global.DefDef): Unit

47. #### def genPlainClass(cd: Global.ClassDef): Unit

48. #### def getAnnotPickle(jclassName: String, sym: Global.Symbol): Option[Global.AnnotationInfo]

    Definition Classes
      BCPickles

49. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

50. #### final def getClassBTypeAndRegisterInnerClass(sym: Global.Symbol): BTypesFromSymbols.ClassBType

    The ClassBType for a class symbol.

    The ClassBType for a class symbol. If the class is nested, the ClassBType is added to the innerClassBufferASM.

    TODO: clean up the way we track referenced inner classes. doing it during code generation is not correct when the optimizer changes the code.

    Definition Classes
      BCInnerClassGen

51. #### def getCurrentCUnit(): Global.CompilationUnit

    Definition Classes
      PlainSkelBuilder → BCJGenSigGen

52. #### def getExceptions(excs: List[Global.AnnotationInfo]): List[String]

    Definition Classes
      BCForwardersGen

53. #### def getGenericSignature(sym: Global.Symbol, owner: Global.Symbol): String

    Definition Classes
      BCJGenSigGen

54. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

55. #### val indyLambdaHosts: Set[Global.Symbol]

    Attributes
      protected

56. #### def initJMethod(flags: Int, paramAnnotations: List[List[Global.AnnotationInfo]]): Unit

57. #### final val innerClassBufferASM: Set[BTypesFromSymbols.ClassBType]

    Definition Classes
      BCInnerClassGen

58. #### var insideCleanupBlock: Boolean

59. #### final def internalName(sym: Global.Symbol): String

    The class internal name for a given class symbol.

    The class internal name for a given class symbol. If the symbol describes a nested class, the ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

60. #### def isAndroidParcelableClass(sym: Global.Symbol): Boolean

    Definition Classes
      JAndroidBuilder

61. #### def isAtProgramPoint(lbl: Label): Boolean

62. #### var isCZParcelable: Boolean

63. #### var isCZRemote: Boolean

64. #### var isCZStaticModule: Boolean

65. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

66. #### var isMethSymStaticCtor: Boolean

67. #### var isModuleInitialized: Boolean

68. #### var jMethodName: String

69. #### var jumpDest: Map[Global.Symbol, Label]

70. #### var labelDef: Map[Global.Symbol, Global.LabelDef]

71. #### var labelDefsAtOrUnder: Map[Global.Tree, List[Global.LabelDef]]

72. #### var lastEmittedLineNr: Int

73. #### def lastInsn: AbstractInsnNode

74. #### def legacyAddCreatorCode(clinit: MethodVisitor, cnode: ClassNode, thisName: String): Unit

    Definition Classes
      JAndroidBuilder

75. #### def lineNumber(tree: Global.Tree): Unit

76. #### object locals

77. #### def log(msg: ⇒ AnyRef): Unit

78. #### def markProgramPoint(lbl: Label): Unit

79. #### var methSymbol: Global.Symbol

80. #### var mnode: MethodNode

81. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

82. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

83. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

84. #### def paramTKs(app: Global.Apply): List[BTypesFromSymbols.BType]

85. #### def pickleMarkerForeign: Attribute

    Definition Classes
      BCPickles

86. #### def pickleMarkerLocal: Attribute

    Definition Classes
      BCPickles

87. #### def programPoint(labelSym: Global.Symbol): Label

88. #### def registerCleanup(finCleanup: Label): Unit

89. #### def resetMethodBookkeeping(dd: Global.DefDef): Unit

90. #### var returnType: BTypesFromSymbols.BType

91. #### var shouldEmitCleanup: Boolean

92. #### def symInfoTK(sym: Global.Symbol): BTypesFromSymbols.BType

93. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

94. #### var thisName: String

95. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

96. #### final def toTypeKind(t: Global.Type): BTypesFromSymbols.BType

    The BType for a type reference.

    The BType for a type reference. If the result is a ClassBType for a nested class, it is added to the innerClassBufferASM. TODO: clean up the way we track referenced inner classes.

    Definition Classes
      BCInnerClassGen

97. #### def tpeTK(tree: Global.Tree): BTypesFromSymbols.BType

98. #### def unregisterCleanup(finCleanup: Label): Unit

99. #### var varsInScope: List[(Global.Symbol, Label)]

100. #### val versionPickle: PickleBuffer

     Definition Classes
       BCPickles

101. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

102. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

103. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

104. #### def →[B](y: B): (PlainSkelBuilder, B)

     Implicit information
       This member is added by an implicit conversion from PlainSkelBuilder to ArrowAssoc[PlainSkelBuilder] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Inherited from BCodeSkelBuilder.BCPickles

### Inherited from BCodeSkelBuilder.BCForwardersGen

### Inherited from BCodeSkelBuilder.BCJGenSigGen

### Inherited from BCodeSkelBuilder.JAndroidBuilder

### Inherited from BCodeSkelBuilder.BCAnnotGen

### Inherited from BCodeSkelBuilder.BCClassGen

### Inherited from BCodeSkelBuilder.BCInnerClassGen

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from PlainSkelBuilder to any2stringadd[PlainSkelBuilder]

### Inherited by implicit conversion StringFormat from PlainSkelBuilder to StringFormat[PlainSkelBuilder]

### Inherited by implicit conversion Ensuring from PlainSkelBuilder to Ensuring[PlainSkelBuilder]

### Inherited by implicit conversion ArrowAssoc from PlainSkelBuilder to ArrowAssoc[PlainSkelBuilder]

### Ungrouped